﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Net;


namespace WindowsFormsApplication1
{
    using System.Net;
    using System.Threading;
    using System.Threading.Tasks;

    public partial class Form1 : Form
    {
        WebClient wc;
        
        public Form1()
        {
            InitializeComponent();
            Write("Bereit.");
        }

        private async void btnStart_Click(object sender,
                EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            Write("Click-Ereignishandler ist gestartet.");

            wc = new WebClient();
            try
            {
                string result = await wc.DownloadStringTaskAsync(
                    new Uri("http://gyorgybalassy.wordpress.com"));
                Write("Download abgeschlossen. " +
                    "Heruntergeladene Bytes: " +
                    result.Length.ToString());
            }
            catch (WebException)
            {
                Write("Download abgebrochen.");
            }

            Write("Click-Ereignishandler ist beendet.");
            wc = null;
            this.Cursor = Cursors.Default;
        }

        private void OnDownloadCompleted(object sender,
            DownloadStringCompletedEventArgs e)
        {
            Write("Download ist abgeschlossen. " +
                "Heruntergeladene Bytes: " +
                e.Result.Length.ToString());
        }

        private void Write(string message)
        {
            this.txtStatus.Text += message + "\r\n";
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            if (wc != null)
            {
                Write("Abbruch ist gestart.");
                wc.CancelAsync();
                Write("Abbruch ist beendet.");
            }

        }

    }
}
