﻿// Eine Einführung zur leeren Vorlage finden Sie in der folgenden Dokumentation:
// http://go.microsoft.com/fwlink/?LinkId=232509
(function () {
    "use strict";

    WinJS.Binding.optimizeBindingReferences = true;

    var app = WinJS.Application;
    var activation = Windows.ApplicationModel.Activation;

    app.onactivated = function (args) {
        if (args.detail.kind === activation.ActivationKind.launch) {
            if (args.detail.previousExecutionState !== activation.ApplicationExecutionState.terminated) {
                // TODO: Diese Anwendung wurde neu eingeführt. Die Anwendung
                // hier initialisieren.
                var btnSearch = document.getElementById("btnSearch");
                btnSearch.addEventListener("click", onSearchButtonClicked);
            } else {
                // TODO: Diese Anwendung war angehalten und wurde reaktiviert.
                // Anwendungszustand hier wiederherstellen.
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    app.oncheckpoint = function (args) {
        // TODO: Diese Anwendung wird gleich angehalten. Jeden Zustand,
        // der über Anhaltevorgänge hinweg beibehalten muss, hier speichern. Dazu kann das
        // WinJS.Application.sessionState-Objekt verwendet werden, das automatisch
        // über ein Anhalten hinweg gespeichert und wiederhergestellt wird. Wenn ein asynchroner
        // Vorgang vor dem Anhalten der Anwendung abgeschlossen werden muss,
        // args.setPromise() aufrufen.
    };

    app.start();
})();

function onSearchButtonClicked(e) {
    var txtKeyword = document.getElementById("txtKeyword");
    var divStatus = document.getElementById("divStatus");
    var divResult = document.getElementById("divResult");

    var url = "http://search.twitter.com/search.json?q="
        + txtKeyword.value;

    WinJS.xhr({ url: url })
      .then(
        function complete(result) {
            divStatus.style.backgroundColor = "lightGreen";
            divStatus.innerHTML = "Herunterladen von "
                + result.response.length
                + " Bytes abgeschlossen. <br />";

            var hits = JSON.parse(result.responseText).results;

            for (var i = 0; i < hits.length; i++) {
                divResult.innerHTML += hits[i].text + "<br/>";
            }
        },

        function error(e) {
            divStatus.style.backgroundColor = "red";
            divStatus.innerHTML = "Houston, wir haben ein Problem!";
        },

        function progress(result) {
            divStatus.style.backgroundColor = "blue";
            divStatus.innerHTML = "Herunterladen von "
                + result.response.length
                + " Bytes. <br />";
        }
    );
}
