﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace NetFxAsyncHistory
{
	using System.IO;
	using System.Net;

	public partial class APMForm : Form
	{
		public APMForm()
		{
			InitializeComponent();
		}

		private void btnDownload_Click( object sender, EventArgs e )
		{
			string url = @"http://gyorgybalassy.wordpress.com";
			this.StartDownload( url );
			this.ReportStatus( "Request sent." );
		}

		delegate void StatusHandler( string message );

		private void StartDownload( string url )
		{
			HttpWebRequest req = (HttpWebRequest) WebRequest.Create( url );
			IAsyncResult result = req.BeginGetResponse( this.OnResponse, req );			
		}

		private void OnResponse( IAsyncResult result )
		{
			HttpWebRequest req = (HttpWebRequest) result.AsyncState;
			HttpWebResponse resp = (HttpWebResponse) req.EndGetResponse( result );
			Stream str = resp.GetResponseStream();
			// TODO: process the response stream here
			this.Invoke( new StatusHandler( this.ReportStatus ), new object[] { "Download finished." } );
		}

		private void ReportStatus( string message )
		{
			this.txtStatus.Text += message + "\r\n";
		}

	}
}
