﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace NetFxAsyncHistory
{
	using System.Net;

	public partial class EAPForm : Form
	{
		public EAPForm()
		{
			InitializeComponent();
		}

		private void btnDownload_Click( object sender, EventArgs e )
		{
			string url = @"http://gyorgybalassy.wordpress.com";

			// Downloading with EAP:
			this.StartDownload( url );

			// Downloading with EAP and lambda expression:
			//WebClient wc = new WebClient();
			//wc.DownloadStringCompleted += ( s, args ) =>
			//  {
			//    string result = args.Result;
			//    // TODO: Process the string result here.
			//    this.Invoke( new StatusHandler( this.ReportStatus ), new object[] { "Download finished with lambda." } );
			//  };
			//wc.DownloadStringAsync( new Uri( url ) );

			this.ReportStatus( "Request sent." );
		}

		delegate void StatusHandler( string message );

		private void StartDownload( string url )
		{
			WebClient wc = new WebClient();
			wc.DownloadStringCompleted += this.OnCompleted;
			wc.DownloadStringAsync( new Uri( url ) );
		}

		private void OnCompleted( object sender, DownloadStringCompletedEventArgs e )
		{
			string result = e.Result;
			// TODO: Process the string result here.
			this.Invoke( new StatusHandler( this.ReportStatus ), new object[] { "Download finished." } );
		}

		private void ReportStatus( string message )
		{
			this.txtStatus.Text += message + "\r\n";
		}

	}
}
