﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace NetFxAsyncHistory
{
	using System.Net;
	using System.Threading;
	using System.Threading.Tasks;

	public partial class TAPForm : Form
	{
		public TAPForm()
		{
			InitializeComponent();
		}

		private void btnDownload_Click( object sender, EventArgs e )
		{
			string url = @"http://gyorgybalassy.wordpress.com";
			this.DownloadTaskAsync( url );
			this.ReportStatus( "Request sent." );
		}


		delegate void StatusHandler( string message );

		private void Download( string url )
		{
			Task.Factory.StartNew( () =>
			{
				WebClient wc = new WebClient();
				string result = wc.DownloadString( url );
				// TODO: Process the string result here.
				this.Invoke( new StatusHandler( this.ReportStatus ), new object[] { "Download finished." } );
			} );
		}


		private void DownloadTaskAsync( string url )
		{
			WebClient wc = new WebClient();
			var task = wc.DownloadStringTaskAsync( url );
			// TODO: Process the task.Result string here.
			task.ContinueWith( _ =>
				{
					this.txtStatus.Text = task.Result;
				} );
		}


		private void ReportStatus( string message )
		{
			this.txtStatus.Text += message + "\r\n";
		}

	}
}
