﻿// Eine Einführung zur leeren Vorlage finden Sie in der folgenden Dokumentation:
// http://go.microsoft.com/fwlink/?LinkId=232509
(function () {
    "use strict";

    WinJS.Binding.optimizeBindingReferences = true;

    var app = WinJS.Application;
    var activation = Windows.ApplicationModel.Activation;

    app.onactivated = function (args) {
        if (args.detail.kind === activation.ActivationKind.launch) {
            if (args.detail.previousExecutionState !== activation.ApplicationExecutionState.terminated) {
                // TODO: Diese Anwendung wurde neu eingeführt. Die Anwendung
                // hier initialisieren.
                var btnOpen = document.getElementById('btnOpen');
                btnOpen.addEventListener('click', onOpenButtonClicked);

                var btnSave = document.getElementById('btnSave');
                btnSave.addEventListener('click', onSaveButtonClicked);
            } else {
                // TODO: Diese Anwendung war angehalten und wurde reaktiviert.
                // Anwendungszustand hier wiederherstellen.
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    app.oncheckpoint = function (args) {
        // TODO: Diese Anwendung wird gleich angehalten. Jeden Zustand,
        // der über Anhaltevorgänge hinweg beibehalten muss, hier speichern. Dazu kann das
        // WinJS.Application.sessionState-Objekt verwendet werden, das automatisch
        // über ein Anhalten hinweg gespeichert und wiederhergestellt wird. Wenn ein asynchroner
        // Vorgang vor dem Anhalten der Anwendung abgeschlossen werden muss,
        // args.setPromise() aufrufen.
    };

    app.start();
})();

function onOpenButtonClicked() {
    var picker = new Windows.Storage.Pickers.FileOpenPicker();
    picker.suggestedStartLocation = Windows.Storage.Pickers.PickerLocationId.desktop;
    picker.fileTypeFilter.replaceAll(['.txt', '.ini', '.log']);

    picker.pickSingleFileAsync().then(function (file) {
        if (file !== null) {
            var lblPath = document.getElementById('lblPath');
            lblPath.innerText = file.path;

            Windows.Storage.FileIO.readTextAsync(file)
                .then(function (content) {
                    var txtContent =
                        document.getElementById('txtContent');
                    txtContent.value = content;
                });
        }
    });
}

function onSaveButtonClicked() {
    var txtContent = document.getElementById('txtContent');

    var content = txtContent.value;

    var picker = new Windows.Storage.Pickers.FileSavePicker();
    picker.suggestedStartLocation = Windows.Storage.Pickers.PickerLocationId.desktop;
    picker.fileTypeChoices.insert('Plain text', ['.txt']);
    picker.pickSaveFileAsync().then(function (file) {
        if (file !== null) {
            Windows.Storage.FileIO.writeTextAsync(file, content).then(function () {
                var dlg = new Windows.UI.Popups.MessageDialog(
                'Ihr Inhalt wurde erfolgreich in der Datei ' + file.path + ' gespeichert.', 'Speichen abgeschlossen.');
                dlg.showAsync();
            });
        }
    });
}

