﻿// Eine Einführung zur leeren Vorlage finden Sie in der folgenden Dokumentation:
// http://go.microsoft.com/fwlink/?LinkId=232509

var files = new WinJS.Binding.List;

(function () {
    "use strict";

    WinJS.Binding.optimizeBindingReferences = true;  //***

    var app = WinJS.Application;
    var activation = Windows.ApplicationModel.Activation;
    //WinJS.strictProcessing();

    app.onactivated = function (args) {
        if (args.detail.kind === activation.ActivationKind.launch) {
            if (args.detail.previousExecutionState !== activation.ApplicationExecutionState.terminated) {
                // TODO: Diese Anwendung wurde neu eingeführt. Die Anwendung
                // hier initialisieren.
            } else {
                // TODO: Diese Anwendung war angehalten und wurde reaktiviert.
                // Anwendungszustand hier wiederherstellen.
            }
            args.setPromise(WinJS.UI.processAll().then(function () {
                var lib = Windows.Storage.KnownFolders.picturesLibrary;
                var data = WinJS.Binding.as({ name: lib.name });
                var element = document.getElementById('libtitle');
                WinJS.Binding.processAll(element, data);

                lib.getItemsAsync().then(function (items) {
                    items.forEach(function (item) {
                        if (item.isOfType(Windows.Storage.StorageItemTypes.file)) {
                            files.push({
                                url: URL.createObjectURL(item),
                                name: item.name,
                                path: item.path,
                                date: item.dateCreated
                            });
                        }
                    });
                });

            }));
        }
    };

    app.oncheckpoint = function (args) {
        // TODO: Diese Anwendung wird gleich angehalten. Jeden Zustand,
        // der über Anhaltevorgänge hinweg beibehalten muss, hier speichern. Dazu kann das
        // WinJS.Application.sessionState-Objekt verwendet werden, das automatisch
        // über ein Anhalten hinweg gespeichert und wiederhergestellt wird. Wenn ein asynchroner
        // Vorgang vor dem Anhalten der Anwendung abgeschlossen werden muss,
        // args.setPromise() aufrufen.
    };

    app.start();
})();
