﻿(function () {
    "use strict";

    var images = new WinJS.Binding.List;
    var lib = Windows.Storage.KnownFolders.picturesLibrary;

    lib.getItemsAsync().then(function (items) {
        items.forEach(function (item) {
            if (item.isOfType(
                    Windows.Storage.StorageItemTypes.file)) {
                images.push({
                    url: URL.createObjectURL(item),
                    name: item.name,
                    date: item.dateCreated
                });
            }
        });
    });

    WinJS.Namespace.define("data", {
        items: images
    });
})();
