﻿// Eine Einführung zur leeren Vorlage finden Sie in der folgenden Dokumentation:
// http://go.microsoft.com/fwlink/?LinkId=232509
(function () {
    "use strict";

    WinJS.Binding.optimizeBindingReferences = true;

    var app = WinJS.Application;
    var activation = Windows.ApplicationModel.Activation;
    var appView = Windows.UI.ViewManagement.ApplicationView;
    var appViewState = Windows.UI.ViewManagement.ApplicationViewState;

    app.onactivated = function (args) {
        if (args.detail.kind === activation.ActivationKind.launch) {
            if (args.detail.previousExecutionState !== activation.ApplicationExecutionState.terminated) {
                // TODO: Diese Anwendung wurde neu eingeführt. Die Anwendung
                // hier initialisieren.
            } else {
                // TODO: Diese Anwendung war angehalten und wurde reaktiviert.
                // Anwendungszustand hier wiederherstellen.
            }
            args.setPromise(WinJS.UI.processAll().then(function () {
                window.addEventListener('resize', onResize);
            }));
        }
    };

    app.oncheckpoint = function (args) {
        // TODO: Diese Anwendung wird gleich angehalten. Jeden Zustand,
        // der über Anhaltevorgänge hinweg beibehalten muss, hier speichern. Dazu kann das
        // WinJS.Application.sessionState-Objekt verwendet werden, das automatisch
        // über ein Anhalten hinweg gespeichert und wiederhergestellt wird. Wenn ein asynchroner
        // Vorgang vor dem Anhalten der Anwendung abgeschlossen werden muss,
        // args.setPromise() aufrufen.
    };

    app.start();

    function onResize(eventArgs) {
        refresh(appView.value);
    }

    function refresh(newViewState) {
        var newLayout;

        switch (newViewState) {
            case appViewState.snapped:
                newLayout = new WinJS.UI.ListLayout();
                break;
            case appViewState.filled:
                newLayout = new WinJS.UI.GridLayout();
                break;
            case appViewState.fullScreenLandscape:
                newLayout = new WinJS.UI.GridLayout();
                break;
            case appViewState.fullScreenPortrait:
                newLayout = new WinJS.UI.ListLayout();
                break;
        }

        var lv = document.getElementById('lv').winControl;
        WinJS.UI.setOptions(lv, {
            layout: newLayout
        });
    }

})();
