﻿// Eine Einführung zur leeren Vorlage finden Sie in der folgenden Dokumentation:
// http://go.microsoft.com/fwlink/?LinkId=232509
(function () {
    "use strict";

    WinJS.Binding.optimizeBindingReferences = true;

    var app = WinJS.Application;
    var activation = Windows.ApplicationModel.Activation;

    app.onactivated = function (args) {
        if (args.detail.kind === activation.ActivationKind.launch) {
            if (args.detail.previousExecutionState !== activation.ApplicationExecutionState.terminated) {
                // TODO: Diese Anwendung wurde neu eingeführt. Die Anwendung
                // hier initialisieren.
            } else {
                // TODO: Diese Anwendung war angehalten und wurde reaktiviert.
                // Anwendungszustand hier wiederherstellen.
            }
            args.setPromise(WinJS.UI.processAll());

            var canvas = document.getElementById('canvas');
            var ctx = canvas.getContext('2d');

            var line = '#000';
            var head = '#ffff00';
            var eye = '#fff';
            var pupil = 'green';
            var mouth = '#FF0000';
            var nose = 'BLACK';

            ctx.save();

            ctx.shadowColor = "#999";
            ctx.shadowBlur = 20;
            ctx.shadowOffsetX = 5;
            ctx.shadowOffsetY = 5;

            ctx.fillStyle = head;
            ctx.beginPath();
            ctx.arc(200, 200, 100, 0, Math.PI * 2, false);
            ctx.fill();

            ctx.restore();

            ctx.strokeStyle = line;
            ctx.lineWidth = "2";
            ctx.stroke();

            ctx.strokeStyle = mouth;
            ctx.beginPath();
            ctx.moveTo(135, 225);
            ctx.quadraticCurveTo(200, 285, 265, 225);
            ctx.stroke();

            ctx.moveTo(135, 225);
            ctx.quadraticCurveTo(200, 310, 265, 225);
            ctx.stroke();

            ctx.strokeStyle = line;
            ctx.fillStyle = eye;
            ctx.lineWidth = '1';

            ctx.beginPath();
            ctx.arc(160, 160, 15, 0, Math.PI * 2, false);
            ctx.stroke();
            ctx.fill();

            ctx.beginPath();
            ctx.arc(240, 160, 15, 0, Math.PI * 2, false);
            ctx.stroke();
            ctx.fill();

            ctx.fillStyle = pupil;
            ctx.beginPath();

            ctx.arc(162, 162, 6, 0, Math.PI * 2, false);
            ctx.fill();

            ctx.beginPath();
            ctx.arc(238, 162, 6, 0, Math.PI * 2, false);
            ctx.fill();

            ctx.save();

            ctx.fillStyle = nose;
            ctx.translate(200, 190);
            ctx.rotate(45 * Math.PI / 180);

            ctx.beginPath();
            ctx.fillRect(0, 0, 16, 16);
            ctx.fill();

            ctx.restore();

            ctx.font = '48px Calibri';
            var text = 'Smile!';
            var textSize = ctx.measureText(text);
            var textx = 200 - textSize.width / 2;
            ctx.strokeText(text, textx, 360);
            ctx.fillText(text, textx, 360);

        }
    };

    app.oncheckpoint = function (args) {
        // TODO: Diese Anwendung wird gleich angehalten. Jeden Zustand,
        // der über Anhaltevorgänge hinweg beibehalten muss, hier speichern. Dazu kann das
        // WinJS.Application.sessionState-Objekt verwendet werden, das automatisch
        // über ein Anhalten hinweg gespeichert und wiederhergestellt wird. Wenn ein asynchroner
        // Vorgang vor dem Anhalten der Anwendung abgeschlossen werden muss,
        // args.setPromise() aufrufen.
    };

    app.start();
})();
