﻿// Eine Einführung zur leeren Vorlage finden Sie in der folgenden Dokumentation:
// http://go.microsoft.com/fwlink/?LinkId=232509
(function () {
    "use strict";

    WinJS.Binding.optimizeBindingReferences = true;

    var app = WinJS.Application;
    var activation = Windows.ApplicationModel.Activation;

    app.onactivated = function (args) {
        if (args.detail.kind === activation.ActivationKind.launch) {
            if (args.detail.previousExecutionState !== activation.ApplicationExecutionState.terminated) {
                // TODO: Diese Anwendung wurde neu eingeführt. Die Anwendung
                // hier initialisieren.
                var headings = document.querySelectorAll('h1, h2');
                WinJS.UI.Animation.enterPage(headings, { top: '100px', left: '500px' });

                btnShow.addEventListener('click', onBtnShowClicked);
                btnNext.addEventListener('click', onBtnNextClicked);
                btnHide.addEventListener('click', onBtnHideClicked);

                btnShowPanel.addEventListener('click', onBtnShowPanelClicked);
                btnHidePanel.addEventListener('click', onBtnHidePanelClicked);
            } else {
                // TODO: Diese Anwendung war angehalten und wurde reaktiviert.
                // Anwendungszustand hier wiederherstellen.
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    app.oncheckpoint = function (args) {
        // TODO: Diese Anwendung wird gleich angehalten. Jeden Zustand,
        // der über Anhaltevorgänge hinweg beibehalten muss, hier speichern. Dazu kann das
        // WinJS.Application.sessionState-Objekt verwendet werden, das automatisch
        // über ein Anhalten hinweg gespeichert und wiederhergestellt wird. Wenn ein asynchroner
        // Vorgang vor dem Anhalten der Anwendung abgeschlossen werden muss,
        // args.setPromise() aufrufen.
    };

    app.start();

    function onBtnShowClicked() {
        WinJS.UI.Animation.enterContent(content1);
        btnShow.style.display = 'none';
        btnNext.style.display = 'inline';
    }

    function onBtnNextClicked() {
        WinJS.UI.Animation.exitContent(content1).then(function () {
            content1.style.display = 'none';
            content2.style.display = 'block';
            btnNext.style.display = 'none';
            btnHide.style.display = 'inline';
            return WinJS.UI.Animation.enterContent(content2);
        });
    }

    function onBtnHideClicked() {
        WinJS.UI.Animation.exitContent(content2);
        content1.style.display = 'block';
        content2.style.display = 'none';
        btnShow.style.display = 'inline';
        btnNext.style.display = 'none';
        btnHide.style.display = 'none';
    }

    function onBtnShowPanelClicked() {
        panel.style.opacity = '1';
        WinJS.UI.Animation.showPanel(panel);
    }

    function onBtnHidePanelClicked() {
        WinJS.UI.Animation.hidePanel(panel).then(function () {
            panel.style.opacity = '0';
        });
    }

})();
