﻿using System;
using System.IO;
using System.Threading.Tasks;
using Windows.ApplicationModel;
using Windows.ApplicationModel.Activation;
using Windows.Storage;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

// The Blank Application template is documented at http://go.microsoft.com/fwlink/?LinkId=234227

namespace AppLifeCycleDemo
{
    /// <summary>
    /// Provides application-specific behavior to supplement the default Application class.
    /// </summary>
    sealed partial class App : Application
    {
        private const string APP_DATA_FILE = "MyAppData.txt";

        /// <summary>
        /// Initializes the singleton application object.
        /// </summary>
        public App()
        {
            this.InitializeComponent();
            this.Suspending += OnSuspending;
            this.Resuming += OnResuming;
            DelayOnSuspending = TimeSpan.FromMilliseconds(100);
       }

        /// <summary>
        /// Invoked when the application is launched normally by the end user.  Other entry points
        /// will be used when the application is launched to open a specific file, to display
        /// search results, and so forth.
        /// </summary>
        /// <param name="args">Details about the launch request and process.</param>
        protected override void OnLaunched(LaunchActivatedEventArgs args)
        {
            EventTracer.WriteLine(
                "Application gestartet. (Kind='{0}', " +
                "PreviousExecutionState='{1}')",
                args.Kind, args.PreviousExecutionState);
            
            // Do not repeat app initialization when already running, just ensure that
            // the window is active
            if (args.PreviousExecutionState == ApplicationExecutionState.Running)
            {
                Window.Current.Activate();
                return;
            }

            // Create a Frame to act navigation context and navigate to the first page
            var rootFrame = new Frame();
            if (!rootFrame.Navigate(typeof(MainPage)))
            {
                throw new Exception("Startseite konnte nicht erstellt werden.");
            }

            // Place the frame in the current Window and ensure that it is active
            Window.Current.Content = rootFrame;
            Window.Current.Activate();
        }

        public static TimeSpan DelayOnSuspending { get; set; }

        /// <summary>
        /// Invoked when application execution is being suspended. Application state is saved
        /// without knowing whether the application will be terminated or resumed with the contents
        /// of memory still intact.
        /// </summary>
        /// <param name="sender">The source of the suspend request.</param>
        /// <param name="e">Details about the suspend request.</param>
        private async void OnSuspending(object sender, SuspendingEventArgs e)
        {
            var deferral = e.SuspendingOperation.GetDeferral();
            EventTracer.WriteLine("Applikation wird angehalten.");
            await Task.Delay(DelayOnSuspending);
            EventTracer.WriteLine(
                    "Die App hat nach dem Speichern ihres Zustands " +
                    "noch {0} ms Zeit.",
                    (e.SuspendingOperation.Deadline - DateTime.Now)
                            .TotalMilliseconds);
            deferral.Complete();
        }

        /// <summary>
        /// Invoked when the application execution is being resumed. Generally, application
        /// state is restored in this method.
        /// </summary>
        /// <param name="sender">The source of the resume request.</param>
        /// <param name="e">Details about the resume request.</param>
        void OnResuming(object sender, object e)
        {
            EventTracer.WriteLine("Applikation wird fortgesetzt.");
        }
    }
}
