﻿using System;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace AppLifeCycleDemo
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
            EventTracer.TraceAdded += OnTraceAdded;
        }

        void OnTraceAdded(object sender, EventLoggedArgs e)
        {
            OutputText.Text += e.Message;
        }

        private void PageLoaded(object sender, RoutedEventArgs e)
        {
            OutputText.Text = EventTracer.EventTrace;
        }

        private void LowDelayButton_Click(object sender, RoutedEventArgs e)
        {
            App.DelayOnSuspending = TimeSpan.FromMilliseconds(100);
            EventTracer.WriteLine("Suspension delay set to 100ms (just OK).");
        }

        private void HighDelayButton_Click(object sender, RoutedEventArgs e)
        {
            App.DelayOnSuspending = TimeSpan.FromSeconds(10);
            EventTracer.WriteLine("Suspension delay set to 10s (too high).");
        }
    }
}
