﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.ApplicationSettings;
using Windows.UI.Popups;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace SimplePuzzle
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        private GameController _game;
        private int _height;
        private int _width;

        public MainPage()
        {
            this.InitializeComponent();
        }

        private void Page_Loaded(object sender, RoutedEventArgs e)
        {
            _game = new GameController(PuzzleCanvas);
            _game.GameStarted += (s, arg) => VisualStateManager.GoToState(this, "InProgress", true);
            _game.GameCompleted += GameCompleted;
            _height = 3;
            _width = 3;
            StartNewGame();
        }

        private void StartNewGame()
        {
            _game.StartNew(_height, _width);
        }

        private void GameCompleted(object sender, EventArgs e)
        {
            _game.StartNew(_height, _width);
        }
    }
}
