﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Popups;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace DiveLog
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class Step3 : Page
    {
        private static bool _lastCancelled;
        public Step3()
        {
            this.InitializeComponent();
            _lastCancelled = false;
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            NavigationModeLabel.Text = e.NavigationMode.ToString();
            SourcePageLabel.Text = e.SourcePageType.Name;
            ParameterLabel.Text = (e.Parameter ?? "<none>").ToString();
            UriLabel.Text = e.Uri == null ? "<none>" : e.Uri.ToString();
        }

        protected async override void OnNavigatedFrom(NavigationEventArgs e)
        {
            var dialog = new MessageDialog(
                "Sie verlassen die Schritt3-Seite.",
                "Navigation Message");
            dialog.Commands.Add(new UICommand("OK"));
            await dialog.ShowAsync();
            base.OnNavigatedFrom(e);
        }

        protected override void OnNavigatingFrom(NavigatingCancelEventArgs e)
        {
            _lastCancelled = !_lastCancelled;
            e.Cancel = _lastCancelled;
            if (_lastCancelled) NavigationModeLabel.Text = "Navigation abgebrochen";
            base.OnNavigatingFrom(e);
        }

        private void GoBack(object sender, RoutedEventArgs e)
        {
            if (this.Frame != null && this.Frame.CanGoBack) this.Frame.GoBack();
        }

        private void NextEntryButtonClick(object sender, RoutedEventArgs e)
        {
            Frame.Navigate(typeof(MainPage), Frame.BackStackDepth);
        }
    }
}
