﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// Die Elementvorlage "Leere Seite" ist unter http://go.microsoft.com/fwlink/?LinkId=234238 dokumentiert.

namespace AccelGyroSample
{
    /// <summary>
    /// Eine leere Seite, die eigenständig verwendet werden kann oder auf die innerhalb eines Rahmens navigiert werden kann.
    /// </summary>
    public sealed partial class MainPage : Page
    {

        #region DependencyProperties
        public bool AcmEnabled
        {
            get { return (bool)GetValue(AcmEnabledProperty); }
            set { SetValue(AcmEnabledProperty, value); }
        }
        public static readonly DependencyProperty AcmEnabledProperty =
            DependencyProperty.Register("AcmEnabled", typeof(bool),
            typeof(MainPage), new PropertyMetadata(false));

        public bool GyroEnabled
        {
            get { return (bool)GetValue(GyroEnabledProperty); }
            set { SetValue(GyroEnabledProperty, value); }
        }
        public static readonly DependencyProperty GyroEnabledProperty =
            DependencyProperty.Register("GyroEnabled", typeof(bool),
            typeof(MainPage), new PropertyMetadata(false));

        #endregion



        public MainPage()
        {
            this.InitializeComponent();
        }

        /// <summary>
        /// Wird aufgerufen, wenn diese Seite in einem Rahmen angezeigt werden soll.
        /// </summary>
        /// <param name="e">Ereignisdaten, die beschreiben, wie diese Seite erreicht wurde. Die
        /// Parametereigenschaft wird normalerweise zum Konfigurieren der Seite verwendet.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }
    }
}
