#pragma once

#include "pch.h"
#include <collection.h>

using namespace std;
using namespace Windows::Foundation;

namespace MatrixDemo
{
// This class defines matrix multiplication operations that can be executed 
// in async manner
public ref class MatrixOperation sealed
{
public:
	MatrixOperation();

	IAsyncOperation<unsigned long long>^ MultiplyMatrixSeriallyAsync();
	IAsyncOperation<unsigned long long>^ MultiplyMatrixWithAMPAsync();

private:
	static void CreateRandomMatrix(int rows, int cols, vector<float>& matrix);
	static void MultiplySequential(vector<float>& vC, 
		const vector<float>& vA, 
		const vector<float>& vB, 
		int M, int N, int W);
	static void MultiplyAMP(vector<float>& vC, 
		const vector<float>& vA, 
		const vector<float>& vB, 
		int M, int N, int W);
	static unsigned long long DoMultiplication(void (* mult)(vector<float>& vC, 
		const vector<float>& vA, 
		const vector<float>& vB, 
		int M, int N, int W));
};

}
