// ModernCpp.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "rectangle.h"
#include <iostream>
#include <memory>
#include <vector>
#include <cliext/algorithm>

using namespace std;
using namespace cliext;

int _tmain(int argc, _TCHAR* argv[])
{
	// --- Create a vector of 10 rectangles
	vector<shared_ptr<rectangle>> shapes;
	for (int i = 1; i <= 10; i++)
	{
		shapes.push_back(shared_ptr<rectangle>(
			new rectangle(i * 100, i * 200)));
	}

	// --- This is the rectangle we are looking for
	auto searchFor = make_shared<rectangle>(300, 600);
	
	// --- Iterate through all rectanges
	for_each(begin(shapes), end(shapes), [&](shared_ptr<rectangle>& rect)
	{
		rect->draw();
		if (rect && *rect == *searchFor)
		{
			cout << "*** Rectangle found." << endl;
		}
	});
	return 0;
}

