﻿#include "pch.h"
#include "Class1.h"
#include <cmath>

using namespace PrimeNumbers;

Prime::Prime() {}

Windows::Foundation::Collections::IVectorView<unsigned long long>^
    Prime::GetPrimes(int upperBound)
{
    // ~DH- Ein Bit-Array erstellen und alle mit 1 initialisieren
    int length = upperBound/8 + 1;
    char* numberFlags = new char[length];
    for (int i = 0; i < length; i++)
        numberFlags[i] = (char)0xff;

    // ~DH- Sieb das Eratosthenes anwenden
    int seekLimit = (int)sqrt(upperBound);
    for (int i = 2; i <= seekLimit; i++)
    {
        if (numberFlags[i>>3] & (0x80 >> i % 8))
        {
            for (int j = i + i; j < upperBound; j += i)
            {
                numberFlags[j>>3] &= ~(0x80 >> j % 8);
            }
        }
    }

    // ~DH- Primzahlen auslesen
    std::vector<unsigned long long> primeNumbers;

    for (int i = 2; i < upperBound; i++)
    {
        if (numberFlags[i>>3] & (0x80 >> i % 8))
            primeNumbers.push_back(i);
    }
    return (ref new Platform::Collections::
        Vector<unsigned long long>(move(primeNumbers)))
            ->GetView();
}
